package ovm.polyd.test;
import static ovm.polyd.PolyD.build;
import static ovm.polyd.PolyD.buildSpecial;

class Test
{
 public static void main(String[] s) {
  test1();
 }
 
 public static void indirect(Dance m,Person p) {
  m.skal(p);
 }
 
 public static void test1() {
  Person james=new Person("James");
  Person alice=new Person("Alice");
  Disco disco=new Disco("The Cavern");
  Park park=new Park("Central Park");
  Worker ellen=new Worker("Ellen");
  Workplace office=new Workplace("BMV");
  Factory acme=new Factory("ACME");
  Place someplace=new Place("somewhere");
  
  ComboA a=new ComboA();
  ComboB b=new ComboB();
  ComboC c=new ComboC("String");
  DanceAux1 aux1=build(DanceAux1.class,a,b,c);
  DanceAux2 aux2=build(DanceAux2.class,a,b,c);
  
  Dance m=build(Dance.class,a,b,c);

  m.concat("Power","Mac");
  m.dance(ellen,acme);
  m.dance(james,disco);
  m.dance(james,acme);
  m.dance(alice,disco);
  m.dance(alice,park);
  m.dance(ellen,park);
  m.dance(ellen,office);
  m.dance(james,office);
  
  m.checkA(james,james);
  m.checkB(james,james);
  
  m.test(5,park);
  m.tast(5,10);
  
  m.quirk("",3.0,park);
  m.nasty();
  m.visit(acme);
  m.visit(park);
  m.visit(disco);
  m.visit(someplace);

  m.quattro("s",'c',ellen,park);
  m.penta("s",4,"t",9,"z");

  Person p=ellen;
  
  indirect(m,p);
  
  m.covar(park);
  
  String dp="Dolly Parton";
  System.out.println("The length of the string \""+dp+"\" is "+m.len(dp));
  dp="Parton Dolly";
  System.out.println("The length of the string \""+dp+"\" is "+m.lx(dp));
  
  m.dance(m.mate(alice),office);

  m.test(6,acme);
  System.out.println("Adding method bodies from \"ComboD\"");
  m=build(Dance.class,a,b,c,new ComboD());
  m.test(6,acme);

  m.line();
  m.visit(park);
  
  aux1.visit(park);
  
  m.line();
  
  aux1.dance(ellen,acme);
  aux1.dance(james,disco);
  aux1.dance(james,acme);
  aux1.dance(alice,disco);
  aux1.dance(alice,park);
  aux1.dance(ellen,park);
  aux1.dance(ellen,office);
  aux1.dance(james,office);

  m.line();
  
  aux2.dance(ellen,acme);
  aux2.dance(james,disco);
  aux2.dance(james,acme);
  aux2.dance(alice,disco);
  aux2.dance(alice,park);
  aux2.dance(ellen,park);
  aux2.dance(ellen,office);
  aux2.dance(james,office);


  m.line();
  m.line();
  m.line();

  m.test(6,acme);
  m.test(6,null);

  m.line();
  m.line();
  m.line();

  m.nonSubsumpDance(ellen,office);
  m.nonSubsumpDance(james,disco);
  m.nonSubsumpDance(james,acme);
  
  m.line();
  m.line();
  m.line();

  
  A aa=new A("aa");
  B bb=new B("bb");
  C cc=new C("cc");
  I ii=build(I.class,new X());

  ii.test(aa);
  ii.test(bb);
  ii.test(cc);
  ii.testAs(bb);


  VisX ii2=buildSpecial(VisI.class,VisX.class,new Object[]{14},new Class[]{int.class});

  ii2.test(aa);
  ii2.test(bb);
  ii2.test(cc);

  RawTest.rawTest();

 }
}

